#include <iostream>
#include <deque>
#include <vector>

int main ()
{
    // Koristimo red sa 2 kraja. Ova strukutra omogucava da mozemo da dodajemo elemente i na kraj i na pocetak.
    // Takodje, elemente mozemo da uklanjamo i sa kraja i sa pocetka.
    std::deque<int> red;
    std::vector<int> a = {5, 8, 12, 4, 2, 13, 19, 1};

    int n = a.size();

    // Prvi element dodamo u deque
    red.push_back(a[0]);

    // Posto je niz specificno zadat, znamo da je element ili manji ili veci od svih elemenata pre njega
    for (int i = 1; i < n; i++) {
        // Dovoljno je uporediti sa krajem deque-a. Ako je element veci, on je veci i od svih prethodno dodatih elemenata,
        // pa ga dodajemo na kraj
        if (a[i] > red.back()) {
            red.push_back(a[i]);
        }
        // U suprotnom, element je manji ili jednal svim prethodno dodatim elementima,
        // pa ga dodajemo na pocetak
        else {
            red.push_front(a[i]);
        }
    }

    for (int x : red) {
        std::cout << x << " ";
    }
    std::cout << "\n";

    return 0;
}