#include <iostream>
#include <queue>

int josif(std::queue<int> djaci, int m)
{
    // Zadatak mozemo resiti koriscenjem kruzne liste, ili na neki nacin to simulirati.
    // Ideja je da koristimo red i da u svakom koraku na kraj reda sa pocetka prebacimo m - 1 element.
    // Time bas m-ti element dolazi na red da se ukloni sto i zelimo da postignemo. Ako smestamo elemente na
    // kraj, prvi element ce se naci nakon poslednjeg i time simuliramo kruznu listu
    while(djaci.size() > 1) {
        for(int i = 0; i < m - 1; i++) {
            djaci.push(djaci.front());
            djaci.pop();
        }

        djaci.pop();
    }
    return djaci.front();
}

int main ()
{
    int n, m;

    std::cin >> n >> m;

    std::queue<int> djaci;

    for (int i = 0; i < n; i++) {
        djaci.push(i);
    }

    std::cout << josif(djaci, m) << "\n";

    return 0;
}